//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2020 - Stephane MOTTELET
//
// This file is hereby licensed under the terms of the GNU GPL v2.0,
// For more information, see the COPYING file which you should have received
//
//--------------------------------------------------------------------------

mode(-1);
lines(0);
try
    version = getversion("scilab");
    assert_checktrue(version(1)+version(2)/10 >= 6.1)
catch
    error(gettext("Scilab 6.1 or more is required."));  
end;

// ====================================================================
if ~with_module("development_tools") then
  error(msprintf(gettext("%s module not installed."),"development_tools"));
end
// ====================================================================
TOOLBOX_NAME = "scicolpack";
TOOLBOX_TITLE = "scicolpack";
// ====================================================================
toolbox_dir = get_absolute_file_path("builder.sce");
// ====================================================================

if ~isdir(toolbox_dir+"/thirdparty/build/ColPack")
    mprintf("Building thirdparty ColPack...\n");
    cd(toolbox_dir+"/thirdparty/build")
    unix_w("sh build.sh")
end

tbx_builder_macros(toolbox_dir);
tbx_builder_gateway(toolbox_dir);
tbx_builder_help(toolbox_dir);
tbx_build_loader(toolbox_dir);

tbx_build_cleaner(toolbox_dir);

cd(toolbox_dir)

clear toolbox_dir TOOLBOX_NAME TOOLBOX_TITLE;
