//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2020 - Stephane MOTTELET
//
// This file is hereby licensed under the terms of the GNU GPL v2.0,
// For more information, see the COPYING file which you should have received
//
//--------------------------------------------------------------------------

function testJac()
    function y=f(x,p)
        x = x(p,:)
        j = size(x,2);
        z = zeros(1,j);
        y = -2*sin(x)+[z;x(1:$-1,:).^2]+[x(2:$,:).^3;z];
        y = [y+y($:-1:1,:)]
        y = [y;y]
    end
    
    N=100;
    rand('seed',7);
    p = samwr(N,1,1:N)
    p = 1:N;
    x0 = rand(N,1,'normal');
    sp = sparse(numderivative(list(f,p),x0));
    
    // get computation engine
    params = struct("FiniteDifferenceType","COMPLEXSTEP","Vectorized","on");
    
    jacobian = spCompJacobian(f,sp,params);
    
    // compute colored Jacobian
    J = jacobian(x0,p);
    clf;
    subplot(1,2,1)
    spycol(J,jacobian.colors)
    title("Colored Jacobian pattern")
    subplot(1,2,2)
    spycol(jacobian.seed,0:size(jacobian.seed,2)-1)
    title("Seed matrix")
endfunction

testJac()
clear testJac
